//  Class: Coordinate Finder Assistance
// Frame to help to find good coordinates for figures in mask sequence
// Mainwork is done in CoordinateImagePanel

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

public class CoordinateFrame extends JFrame {

	CoordinateImagePanel		coordinateImagePanel;

	JLabel				labLine1Head,	labLine2Head;
	JLabel				labLine3Head,	labLine1x1;
	JLabel				labLine2x1,		labLine3x1;
	JLabel				labLine1x1val,	labLine2x1val;
	JLabel				labLine3x1val,	labLine1y1;
	JLabel				labLine2y1,		labLine3y1;
	JLabel				labLine1y1val,	labLine2y1val;
	JLabel				labLine3y1val,	labLine1x2;
	JLabel				labLine2x2,		labLine3x2;
	JLabel				labLine1x2val,	labLine2x2val;
	JLabel				labLine3x2val,	labLine1y2;
	JLabel				labLine2y2,		labLine3y2;
	JLabel				labLine1y2val,	labLine2y2val;
	JLabel				labLine3y2val;

	JButton				buttCrossOnOff,	buttClose;
	JButton				buttZoomIn,		buttZoomOut;

	JPanel				coordinatePanel;

	GridBagConstraints	gbConstraints;

	String imagePath = 	"";

	public CoordinateFrame(String thePath) {								// *** Constructor
		super("Coordinate Finder Assistance");									// Titel des Fensters
		imagePath = thePath;

		setupComponentInstances();
		setupListeningComponents();
		setupComponentInitContent();
		setupComponentStyles();

		makeLayout();

		getContentPane().add(coordinatePanel);

		this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);		// Close Win
		coordinateImagePanel.updateCoordinateValuesExtern();
	}														// *** End Constructor

	// ********************* Window Control Methods *****************

	protected void processWindowEvent(WindowEvent e) {		// Fensterereignisse
		if (e.getID()==WindowEvent.WINDOW_CLOSING) {
			programmBeenden();
		}
	}

	public void centerWindow() {							// Methode zum Zentrieren des Fensters
		Dimension screenSize = Toolkit.getDefaultToolkit ().getScreenSize();
		Dimension frameSize = this.getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}
		this.setLocation((screenSize.width - frameSize.width) / 2,
						(screenSize.height - frameSize.height) / 2);
	}

	public void programmBeenden() {
		dispose();											// Ressourcen des Fensters freigeben
	}

	// *** setter for the Panels callback
	public void setLine1X1(int x1) {
		labLine1x1val.setText(""+x1);
	}
	public void setLine2X1(int x1) {
		labLine2x1val.setText(""+x1);
	}
	public void setLine3X1(int x1) {
		labLine3x1val.setText(""+x1);
	}
	public void setLine1Y1(int y1) {
		labLine1y1val.setText(""+y1);
	}
	public void setLine2Y1(int y1) {
		labLine2y1val.setText(""+y1);
	}
	public void setLine3Y1(int y1) {
		labLine3y1val.setText(""+y1);
	}
	public void setLine1X2(int x2) {
		labLine1x2val.setText(""+x2);
	}
	public void setLine2X2(int x2) {
		labLine2x2val.setText(""+x2);
	}
	public void setLine3X2(int x2) {
		labLine3x2val.setText(""+x2);
	}
	public void setLine1Y2(int y2) {
		labLine1y2val.setText(""+y2);
	}
	public void setLine2Y2(int y2) {
		labLine2y2val.setText(""+y2);
	}
	public void setLine3Y2(int y2) {
		labLine3y2val.setText(""+y2);
	}

	// ********************* Validation and Button Control *******
	public void doButtCrossOnOffAction() {
		coordinateImagePanel.toggleDrawCoordinates();
		coordinateImagePanel.repaint();
	}

	public void doButtCloseAction() {
		programmBeenden();
	}

	public void doButtZoomInAction() {
		coordinateImagePanel.zoomOneIn();
	}
	public void doButtZoomOutAction() {
		coordinateImagePanel.zoomOneOut();
	}

	// ********************* GUI related Methods *****************

	public void setupListeningComponents() {
		// JButton Listeners
		ActionListener buttCrossOnOffListener = new ActionListener() {	// JButton
			public void actionPerformed(ActionEvent e) {
				doButtCrossOnOffAction();
			}
		};
		buttCrossOnOff.addActionListener(buttCrossOnOffListener);
		buttCrossOnOff.setToolTipText("Display Coordinate Cross");

		// JButton Listeners
		ActionListener buttCloseListener = new ActionListener() {	// JButton
			public void actionPerformed(ActionEvent e) {
				doButtCloseAction();
			}
		};
		buttClose.addActionListener(buttCloseListener);
		buttClose.setToolTipText("Close Assistant");

		// JButton Listeners
		ActionListener buttZoomInListener = new ActionListener() {	// JButton
			public void actionPerformed(ActionEvent e) {
				doButtZoomInAction();
			}
		};
		buttZoomIn.addActionListener(buttZoomInListener);
		buttZoomIn.setToolTipText("Zoom In");

		// JButton Listeners
		ActionListener buttZoomOutListener = new ActionListener() {	// JButton
			public void actionPerformed(ActionEvent e) {
				doButtZoomOutAction();
			}
		};
		buttZoomOut.addActionListener(buttZoomOutListener);
		buttZoomOut.setToolTipText("Zoom Out");
	}

	public void setupComponentInstances() {
		coordinatePanel 		= new JPanel();

		coordinateImagePanel	= new CoordinateImagePanel(imagePath, this);

		labLine1Head		= new JLabel();
		labLine2Head		= new JLabel();
		labLine3Head		= new JLabel();
		labLine1x1			= new JLabel();
		labLine2x1			= new JLabel();
		labLine3x1			= new JLabel();
		labLine1x1val		= new JLabel();
		labLine2x1val		= new JLabel();
		labLine3x1val		= new JLabel();
		labLine1y1			= new JLabel();
		labLine2y1			= new JLabel();
		labLine3y1			= new JLabel();
		labLine1y1val		= new JLabel();
		labLine2y1val		= new JLabel();
		labLine3y1val		= new JLabel();
		labLine1x2			= new JLabel();
		labLine2x2			= new JLabel();
		labLine3x2			= new JLabel();
		labLine1x2val		= new JLabel();
		labLine2x2val		= new JLabel();
		labLine3x2val		= new JLabel();
		labLine1y2			= new JLabel();
		labLine2y2			= new JLabel();
		labLine3y2			= new JLabel();
		labLine1y2val		= new JLabel();
		labLine2y2val		= new JLabel();
		labLine3y2val		= new JLabel();

		buttCrossOnOff		= new JButton();
		buttClose			= new JButton();
		buttZoomIn			= new JButton();
		buttZoomOut			= new JButton();
	}

	public void setupComponentInitContent() {
		labLine1Head.setText("Line 1:");
		labLine2Head.setText("Line 2:");
		labLine3Head.setText("Line 3:");
		labLine1x1.setText("X1: ");
		labLine2x1.setText("X1: ");
		labLine3x1.setText("X1: ");
		labLine1x1val.setText("1");
		labLine2x1val.setText("1");
		labLine3x1val.setText("1");
		labLine1y1.setText("Y1: ");
		labLine2y1.setText("Y1: ");
		labLine3y1.setText("Y1: ");
		labLine1y1val.setText("1");
		labLine2y1val.setText("1");
		labLine3y1val.setText("1");
		labLine1x2.setText("X2: ");
		labLine2x2.setText("X2: ");
		labLine3x2.setText("X2: ");
		labLine1x2val.setText("2");
		labLine2x2val.setText("2");
		labLine3x2val.setText("2");
		labLine1y2.setText("Y2: ");
		labLine2y2.setText("Y2: ");
		labLine3y2.setText("Y2: ");
		labLine1y2val.setText("2");
		labLine2y2val.setText("2");
		labLine3y2val.setText("2");

		buttCrossOnOff.setText("Coordinate Cross");
		buttClose.setText("Close");
		buttZoomIn.setText("+");
		buttZoomOut.setText("-");
	}

	public void setupComponentStyles() {
		coordinateImagePanel.setBorder(new EtchedBorder());
		labLine1Head.setFont(labLine1Head.getFont().deriveFont(Font.PLAIN));
		labLine1Head.setHorizontalAlignment(JLabel.LEFT);
		labLine2Head.setFont(labLine2Head.getFont().deriveFont(Font.PLAIN));
		labLine2Head.setHorizontalAlignment(JLabel.LEFT);
		labLine3Head.setFont(labLine3Head.getFont().deriveFont(Font.PLAIN));
		labLine3Head.setHorizontalAlignment(JLabel.LEFT);
		labLine1x1.setFont(labLine1x1.getFont().deriveFont(Font.PLAIN));
		labLine1x1.setHorizontalAlignment(JLabel.LEFT);
		labLine2x1.setFont(labLine2x1.getFont().deriveFont(Font.PLAIN));
		labLine2x1.setHorizontalAlignment(JLabel.LEFT);
		labLine3x1.setFont(labLine3x1.getFont().deriveFont(Font.PLAIN));
		labLine3x1.setHorizontalAlignment(JLabel.LEFT);
		labLine1x1val.setFont(labLine1x1val.getFont().deriveFont(Font.BOLD));
		labLine1x1val.setHorizontalAlignment(JLabel.LEFT);
		labLine2x1val.setFont(labLine2x1val.getFont().deriveFont(Font.BOLD));
		labLine2x1val.setHorizontalAlignment(JLabel.LEFT);
		labLine3x1val.setFont(labLine3x1val.getFont().deriveFont(Font.BOLD));
		labLine3x1val.setHorizontalAlignment(JLabel.LEFT);
		labLine1y1.setFont(labLine1y1.getFont().deriveFont(Font.PLAIN));
		labLine1y1.setHorizontalAlignment(JLabel.LEFT);
		labLine2y1.setFont(labLine2y1.getFont().deriveFont(Font.PLAIN));
		labLine2y1.setHorizontalAlignment(JLabel.LEFT);
		labLine3y1.setFont(labLine3y1.getFont().deriveFont(Font.PLAIN));
		labLine3y1.setHorizontalAlignment(JLabel.LEFT);
		labLine1y1val.setFont(labLine1y1val.getFont().deriveFont(Font.BOLD));
		labLine1y1val.setHorizontalAlignment(JLabel.LEFT);
		labLine2y1val.setFont(labLine2y1val.getFont().deriveFont(Font.BOLD));
		labLine2y1val.setHorizontalAlignment(JLabel.LEFT);
		labLine3y1val.setFont(labLine3y1val.getFont().deriveFont(Font.BOLD));
		labLine3y1val.setHorizontalAlignment(JLabel.LEFT);
		labLine1x2.setFont(labLine1x2.getFont().deriveFont(Font.PLAIN));
		labLine1x2.setHorizontalAlignment(JLabel.LEFT);
		labLine2x2.setFont(labLine2x2.getFont().deriveFont(Font.PLAIN));
		labLine2x2.setHorizontalAlignment(JLabel.LEFT);
		labLine3x2.setFont(labLine3x2.getFont().deriveFont(Font.PLAIN));
		labLine3x2.setHorizontalAlignment(JLabel.LEFT);
		labLine1x2val.setFont(labLine1x2val.getFont().deriveFont(Font.BOLD));
		labLine1x2val.setHorizontalAlignment(JLabel.LEFT);
		labLine2x2val.setFont(labLine2x2val.getFont().deriveFont(Font.BOLD));
		labLine2x2val.setHorizontalAlignment(JLabel.LEFT);
		labLine3x2val.setFont(labLine3x2val.getFont().deriveFont(Font.BOLD));
		labLine3x2val.setHorizontalAlignment(JLabel.LEFT);
		labLine1y2.setFont(labLine1y2.getFont().deriveFont(Font.PLAIN));
		labLine1y2.setHorizontalAlignment(JLabel.LEFT);
		labLine2y2.setFont(labLine2y2.getFont().deriveFont(Font.PLAIN));
		labLine2y2.setHorizontalAlignment(JLabel.LEFT);
		labLine3y2.setFont(labLine3y2.getFont().deriveFont(Font.PLAIN));
		labLine3y2.setHorizontalAlignment(JLabel.LEFT);
		labLine1y2val.setFont(labLine1y2val.getFont().deriveFont(Font.BOLD));
		labLine1y2val.setHorizontalAlignment(JLabel.LEFT);
		labLine2y2val.setFont(labLine2y2val.getFont().deriveFont(Font.BOLD));
		labLine2y2val.setHorizontalAlignment(JLabel.LEFT);
		labLine3y2val.setFont(labLine3y2val.getFont().deriveFont(Font.BOLD));
		labLine3y2val.setHorizontalAlignment(JLabel.LEFT);
	}

	public void makeLayout() {
		gbConstraints = new GridBagConstraints();
		coordinatePanel.setLayout(new GridBagLayout());

		gbConstraints.gridx = 0;
		gbConstraints.gridy = 0;
		gbConstraints.gridwidth = 2;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 0.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.insets = new Insets(2, 2, 2, 2);		// top, left, bottom, right
		gbConstraints.anchor = GridBagConstraints.LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(buttCrossOnOff, gbConstraints);

		gbConstraints.gridx = 2;
		gbConstraints.gridy = 0;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 0.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.LINE_END;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(buttZoomIn, gbConstraints);

		gbConstraints.gridx = 3;
		gbConstraints.gridy = 0;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 0.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(buttZoomOut, gbConstraints);

		gbConstraints.gridx = 4;
		gbConstraints.gridy = 0;
		gbConstraints.gridwidth = 2;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 0.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.LINE_END;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(buttClose, gbConstraints);

		gbConstraints.gridx = 0;
		gbConstraints.gridy = 1;
		gbConstraints.gridwidth = 6;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 1.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.BOTH;
		coordinatePanel.add(coordinateImagePanel, gbConstraints);

		gbConstraints.gridx = 0;
		gbConstraints.gridy = 2;
		gbConstraints.gridwidth = 2;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine1Head, gbConstraints);

		gbConstraints.gridx = 2;
		gbConstraints.gridy = 2;
		gbConstraints.gridwidth = 2;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine2Head, gbConstraints);

		gbConstraints.gridx = 4;
		gbConstraints.gridy = 2;
		gbConstraints.gridwidth = 2;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine3Head, gbConstraints);

		gbConstraints.gridx = 0;
		gbConstraints.gridy = 3;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine1x1, gbConstraints);

		gbConstraints.gridx = 2;
		gbConstraints.gridy = 3;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine2x1, gbConstraints);

		gbConstraints.gridx = 4;
		gbConstraints.gridy = 3;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine3x1, gbConstraints);

		gbConstraints.gridx = 1;
		gbConstraints.gridy = 3;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine1x1val, gbConstraints);

		gbConstraints.gridx = 3;
		gbConstraints.gridy = 3;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine2x1val, gbConstraints);

		gbConstraints.gridx = 5;
		gbConstraints.gridy = 3;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine3x1val, gbConstraints);

		gbConstraints.gridx = 0;
		gbConstraints.gridy = 4;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine1y1, gbConstraints);

		gbConstraints.gridx = 2;
		gbConstraints.gridy = 4;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine2y1, gbConstraints);

		gbConstraints.gridx = 4;
		gbConstraints.gridy = 4;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine3y1, gbConstraints);

		gbConstraints.gridx = 1;
		gbConstraints.gridy = 4;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine1y1val, gbConstraints);

		gbConstraints.gridx = 3;
		gbConstraints.gridy = 4;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine2y1val, gbConstraints);

		gbConstraints.gridx = 5;
		gbConstraints.gridy = 4;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine3y1val, gbConstraints);

		gbConstraints.gridx = 0;
		gbConstraints.gridy = 5;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine1x2, gbConstraints);

		gbConstraints.gridx = 2;
		gbConstraints.gridy = 5;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine2x2, gbConstraints);

		gbConstraints.gridx = 4;
		gbConstraints.gridy = 5;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine3x2, gbConstraints);

		gbConstraints.gridx = 1;
		gbConstraints.gridy = 5;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine1x2val, gbConstraints);

		gbConstraints.gridx = 3;
		gbConstraints.gridy = 5;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine2x2val, gbConstraints);

		gbConstraints.gridx = 5;
		gbConstraints.gridy = 5;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine3x2val, gbConstraints);

		gbConstraints.gridx = 0;
		gbConstraints.gridy = 6;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine1y2, gbConstraints);

		gbConstraints.gridx = 2;
		gbConstraints.gridy = 6;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine2y2, gbConstraints);

		gbConstraints.gridx = 4;
		gbConstraints.gridy = 6;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.NONE;
		coordinatePanel.add(labLine3y2, gbConstraints);

		gbConstraints.gridx = 1;
		gbConstraints.gridy = 6;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine1y2val, gbConstraints);

		gbConstraints.gridx = 3;
		gbConstraints.gridy = 6;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine2y2val, gbConstraints);

		gbConstraints.gridx = 5;
		gbConstraints.gridy = 6;
		gbConstraints.gridwidth = 1;
		gbConstraints.gridheight = 1;
		gbConstraints.weightx = 1.0;
		gbConstraints.weighty = 0.0;
		gbConstraints.anchor = GridBagConstraints.FIRST_LINE_START;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		coordinatePanel.add(labLine3y2val, gbConstraints);
	}
}	// End of Class